# -*- coding: utf-8 -*-

import cv
import cv2
from scipy import weave

def Traitement(capture,seuil):
    ret,trame=capture.read()
    if ret==True:
        X,Y,numcomp=trame.shape
        trame=cv2.GaussianBlur(trame,(5,5),0)
        cv2.namedWindow('Image')
        cv2.imshow('Image',trame)
        sortie=np.ones((X,Y,numcomp),dtype=np.uint8)
        couleur=np.zeros((1,3))
        weave.inline("""
        for (int x=0; x<X; ++x)
            for (int y=0; y<Y; ++y) 
                {
                    for (int k=0;k<3;k++)
                        couleur(0,k)=trame(x,y,k);
                    float maximum=-1.0;
                    for(int k=0;k<3;k++)
                        if(couleur(0,k)>maximum)
                            maximum=couleur(0,k);
                    float minimum=256.0;
                    for(int k=0;k<3;k++)
                        if(couleur(0,k)<minimum)
                            minimum=couleur(0,k);
                    if(maximum-minimum>=seuil)
                        for(int k=0;k<3;k++)
                            {
                            couleur(0,k)=255*(couleur(0,k)-minimum)/(maximum-minimum);
                            if ((couleur(0,k) != 0.0) && (couleur(0,k) !=255.0))
                                couleur(0,k)=0.0;
                            }
                    else
                        for(int k=0;k<3;k++)
                            couleur(0,k)=0.0;
                    for (int k=0;k<3;k++)
                        sortie(x,y,k)=couleur(0,k);
                }
        """,
        ['trame' ,'sortie', 'X', 'Y', 'couleur','seuil'],
        type_converters=weave.converters.blitz)     
        contours=np.uint8(sortie[:,:,1]==255)
        contoursliste,hierarchy = \
        cv2.findContours(contours,cv2.RETR_EXTERNAL,cv2.CHAIN_APPROX_NONE) 
        nbcont=np.size(contoursliste,0)
        marqueurs=np.zeros((X,Y),dtype=np.int32)    
        index=1
        for k in range(nbcont):    
            uncont=contoursliste[k]
            cv2.drawContours(marqueurs,[uncont],0,index,1)
            index=index+1       
        cv2.namedWindow('Contours objets verts')    
        cv2.imshow('Contours objets verts',255*np.uint8(marqueurs>0))            
        cv2.namedWindow('Couleurs saturees')    
        cv2.imshow('Couleurs saturees',sortie)            

    k=cv2.waitKey(10)
# on quitte en tapant la touche ESC    
    if k%256==27:
        return True
    else:
        return False
        
if __name__=='__main__':
    seuil=20;
    choix=input('Choisir la source :\n1 : webcam\n2 : fichier image \n3 : fichier video\n')
    if choix==1 :
        capture=cv2.VideoCapture(0)
        capture.set(cv.CV_CAP_PROP_FRAME_WIDTH,352)
        capture.set(cv.CV_CAP_PROP_FRAME_HEIGHT,288)        
    elif choix==2 :
        capture=cv2.VideoCapture('balles.jpg')
    else :
        capture=cv2.VideoCapture('news_interview.wmv')
    if capture.isOpened()==False :
        print('source inexistante')
        cv2.destroyAllWindows()
        capture.release()
    else :
        print('Touche ESC pour quitter')    
        while Traitement(capture,seuil)==False:
            pass
        cv2.destroyAllWindows()
        capture.release()