# -*- coding: utf-8 -*-

import cv2

def Traitement(capture,seuil,couleur):
    ret,trame=capture.read()
    if ret==True:
        X,Y,numcomp=trame.shape
        gris = cv2.cvtColor(trame,cv2.COLOR_BGR2GRAY)
        flou=cv2.GaussianBlur(gris,(9,9),0)
        contx=cv2.Sobel(flou,cv2.CV_64F,1,0)
        conty=cv2.Sobel(flou,cv2.CV_64F,0,1)
        cont=abs(contx)+abs(conty)
        contours=np.uint8(cont<seuil);        
        contoursliste,hierarchy = \
        cv2.findContours(contours,cv2.RETR_CCOMP,cv2.CHAIN_APPROX_NONE) 
        nbcont=np.size(contoursliste,0)
        marqueurs=np.zeros((X,Y),dtype=np.int32)    
        index=1
        for k in range(nbcont):    
            if hierarchy[0][k][3]<0:
                uncont=contoursliste[k]
                cv2.drawContours(marqueurs,[uncont],0,index,1)
                index=index+1
        cv2.watershed(trame,marqueurs)
        trame[marqueurs==-1]=couleur
        cv2.namedWindow('Lignes de partage des eaux')
        cv2.imshow('Lignes de partage des eaux',trame)
        cv2.namedWindow('Norme du gradient')
        cv2.imshow('Norme du gradient',0.3+0.6*cont/255)
            
    k=cv2.waitKey(10)
# on quitte en tapant la touche ESC    
    if k%256==27:
        return True
    else:
        return False
        
if __name__=='__main__':
    seuil=15
    couleur=(0,255,0)    
    choix=input('Choisir la source :\n1 : webcam\n2 : fichier image \n3 : fichier video\n')
    if choix==1 :
        capture=cv2.VideoCapture(0)
    elif choix==2 :
        capture=cv2.VideoCapture('balles1.jpg')
    else :
        capture=cv2.VideoCapture('news_interview.wmv')
    if capture.isOpened()==False :
        print('source inexistante')
        cv2.destroyAllWindows()
        capture.release()
    else :
        print('Touche ESC pour quitter')    
        while Traitement(capture,seuil,couleur)==False:
            pass
        cv2.destroyAllWindows()
        capture.release()