# -*- coding: utf-8 -*-

import cv
import cv2
from scipy import weave

def Traitement(capture,seuil,couleur):
    ret,trame=capture.read()
    if ret==True:
        X,Y,numcomp=trame.shape
        cv2.namedWindow('Image initiale')
        cv2.imshow('Image initiale',trame)
        gris = cv2.cvtColor(trame,cv2.COLOR_BGR2GRAY)
        flou=cv2.GaussianBlur(gris,(5,5),0)
        contx=cv2.Sobel(flou,cv2.CV_64F,1,0)
        conty=cv2.Sobel(flou,cv2.CV_64F,0,1)
        cont=abs(contx)+abs(conty)
        contours=np.uint8(cont<seuil);        
        contoursliste,hierarchy = \
        cv2.findContours(contours,cv2.RETR_CCOMP,cv2.CHAIN_APPROX_NONE) 
        nbcont=np.size(contoursliste,0)
        marqueurs=np.zeros((X,Y),dtype=np.int32)    
        index=1
        for k in range(nbcont):    
            if hierarchy[0][k][3]<0:
                uncont=contoursliste[k]
                cv2.drawContours(marqueurs,[uncont],0,index,1)
                index=index+1
        cv2.watershed(trame,marqueurs)
        couleurs=np.zeros((nbcont,3))
        indexcoul=np.zeros((nbcont,1))
        weave.inline("""
        int numcont,x,y,k,index;
        for(x=0;x<X;x++)
            for(y=0;y<Y;y++)
            {
                index=marqueurs(x,y)-1;
                if (index>=0)
                {
                    indexcoul(index)++;
                    for (k=0;k<3;k++)
                        couleurs(index,k)=
                        couleurs(index,k)+trame(x,y,k);
                }                    
            }
        for(index=0;index<nbcont;index++)
            for (k=0;k<3;k++)
                couleurs(index,k)/=indexcoul(index);
        for(x=0;x<X;x++)
            for(y=0;y<Y;y++)
            {
                index=marqueurs(x,y)-1;
                if (index>=0)
                    for (k=0;k<3;k++)
                        trame(x,y,k)=couleurs(index,k);
            }
        """,
        ['trame' ,'marqueurs', 'X', 'Y', 'nbcont','couleurs','indexcoul'],
        type_converters=weave.converters.blitz)        
        trame[marqueurs==-1]=couleur
        cv2.namedWindow('Lignes de partage des eaux')
        cv2.imshow('Lignes de partage des eaux',trame)
        cv2.namedWindow('Norme du gradient')
        cv2.imshow('Norme du gradient',0.3+0.6*cont/255)
            
    k=cv2.waitKey(10)
# on quitte en tapant la touche ESC    
    if k%256==27:
        return True
    else:
        return False
        
if __name__=='__main__':
    seuil=15
    couleur=(0,0,0)    
    choix=input('Choisir la source :\n1 : webcam\n2 : fichier image \n3 : fichier video\n')
    if choix==1 :
        capture=cv2.VideoCapture(0)
        capture.set(cv.CV_CAP_PROP_FRAME_WIDTH,352)
        capture.set(cv.CV_CAP_PROP_FRAME_HEIGHT,288)        
    elif choix==2 :
        capture=cv2.VideoCapture('balles1.jpg')
    else :
        capture=cv2.VideoCapture('news_interview.wmv')
    if capture.isOpened()==False :
        print('source inexistante')
        cv2.destroyAllWindows()
        capture.release()
    else :
        print('Touche ESC pour quitter')    
        while Traitement(capture,seuil,couleur)==False:
            pass
        cv2.destroyAllWindows()
        capture.release()